namespace eval gesture {
variable lx
variable ly
variable dirs
variable callback
variable full 0
    
proc init {w call {f 0}} {
    bind $w <1>               "[namespace current]::start $w %x %y"
    bind $w <B1-Motion>       "[namespace current]::move $w %x %y"
    bind $w <ButtonRelease-1> "[namespace current]::end $w %x %y"

    variable callback
    set callback $call

    variable full
    set full $f
}

proc start {w x y} {
    variable lx
    variable ly
    variable dirs
    set lx   $x
    set ly   $y
    set dirs ""
}

proc move {w x y} {
    variable lx
    variable ly
    variable dirs

    set dx [expr {$x-$lx}]
    set dy [expr {$y-$ly}]
    if {abs($dx)+abs($dy) < 10} return
    move2 $w $x $y
}

proc move2 {w x y} {
    variable lx
    variable ly
    variable dirs

    set dx [expr {$x-$lx}]
    set dy [expr {$y-$ly}]

    set dir [expr {abs($dx) > abs($dy) ? ($dx>0?"R":"L") : ($dy>0?"D":"U")}]
    set dis [expr {abs($dx) > abs($dy) ? abs($dx) : abs($dy)}]
    set cdir [lindex $dirs end]
    if {$dir != [lindex $cdir 0]} {
	lappend dirs [list $dir $dis $lx $ly]
    } else {
	set cdir [lreplace $cdir 1 1 [expr {[lindex $cdir 1]+$dis}]]
	set dirs [lreplace $dirs end end $cdir]
    }

    $w create line $lx $ly $x $y -tags GESTURE
    set lx $x
    set ly $y
}

proc end {w x y} {
    variable callback
    variable dirs
    variable full

    move2 $w $x $y

    $w delete GESTURE GESTURE_LAST

    if {[lindex [lindex $dirs 0] 1] < 10} return

#    foreach op $dirs {
#	puts $op
#	foreach {dir sz x1 y1} $op break
#	set x2 $x1
#	set y2 $y1
#	switch $dir {
#	    R {incr x2  $sz}
#	    L {incr x2 -$sz}
#	    D {incr y2  $sz}
#	    U {incr y2 -$sz}
#	}
#	$w create line $x1 $y1 $x2 $y2 -tags GESTURE_LAST
#    }

    if {$full} {
	eval $callback [list $dirs]
    } else {
	eval $callback [simple $dirs]
    }
}

proc simple {{dlist {}}} {
    variable dirs

    if {$dlist == {}} {
	set dlist $dirs
    }
    set res ""
    foreach op $dlist {
	append res [lindex $op 0]
    }
    return $res
}

}; # namespace eval

#pack [label .l -textvariable gesture::dirs] -fill both
#pack [canvas .c] -fill both -expand 1
#gesture::init .c "callback foo" 
#
#proc callback {cd dirs} {
#    puts :$cd:$dirs
#}
