proc create_tag_editor {ed} {
    set w $ed.tag
    if {[xtoplevel $w] == ""} return

    # Buttons at top
    frame $w.bar
    button $w.bar.cancel \
	-text " Cancel " \
	-command "destroy $w"
    button $w.bar.save \
	-text "Save " \
	-command "tag_editor_save $ed $w"
    pack $w.bar.cancel $w.bar.save -side left

    # Editor panel
    text $w.editor \
	-height 8 \
	-width 20 \
	-xscrollcommand "$w.xscroll set" \
	-yscrollcommand "$w.yscroll set" \
	-bd 2 -relief sunken
    scrollbar $w.xscroll \
	-orient horiz \
	-command "$w.editor xview" \
	-bd 2 -relief sunken
    scrollbar $w.yscroll \
	-orient vertical \
	-command "$w.editor yview" \
	-bd 2 -relief sunken

    grid rowconfigure $w 1 -weight 1
    grid columnconfigure $w 0 -weight 1

    grid $w.bar - -sticky nsew
    grid $w.editor $w.yscroll -sticky nsew
    grid $w.xscroll -sticky nsew
}

proc tag_editor_save {ed w} {
    set io [$ed io]
    set anno [$w.editor get 1.0 end]
    
    puts anno=$anno
    destroy $w
}